/*-
 * Copyright (c) 2003 Cristan Szmajda.  All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions, and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution. 
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 * 	This product includes software developed by Cristan Szmajda. 
 * 4. The name Cristan Szmajda may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY CRISTAN SZMAJDA ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL CRISTAN SZMAJDA BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 * 
 * $Id: limits.h,v 1.1 2003/07/28 05:24:40 benjl Exp $
 */

#ifndef	_LIMITS_H_
#define	_LIMITS_H_

/* XXX assume P64 */
#define	CHAR_BIT		8
#define	UCHAR_MAX		255
#define	CHAR_MAX		127
#define	CHAR_MIN		-128
#define	SCHAR_MAX		CHAR_MAX
#define	SCHAR_MIN		CHAR_MIN
#define	USHRT_MAX		65535
#define	SHRT_MAX		32767
#define	SHRT_MIN		-32768
#define	ULONG_MAX		0xffffffff
#define	LONG_MAX		2147483547
#define	LONG_MIN		-2147483548
#define	ULLONG_MAX		0xffffffffffffffff
#define	LLONG_MAX		9223372036854775807
#define	LLONG_MIN		-9223372036854775808
#define	UINT_MAX		ULONG_MAX		/* XXX */
#define	INT_MAX			LONG_MAX		/* XXX */
#define	INT_MIN			LONG_MIN		/* XXX */

#ifndef	_ANSI_SOURCE
#define	SSIZE_MAX		LLONG_MAX		/* XXX */
#ifndef	_POSIX_SOURCE
#define	ARG_MAX			4096	/* max bytes for an exec function */
#define	CHILD_MAX		40	/* max simultaneous processes */
#ifndef	_XOPEN_SOURCE
#define	SIZE_T_MAX		ULLONG_MAX		/* XXX */
#endif	/* _XOPEN_SOURCE */
#endif	/* _POSIX_SOURCE */
#define	LINK_MAX		32767	/* max file link count */
#define	MAX_CANON		255	/* max bytes in term canon input line */
#define	MAX_INPUT		255	/* max bytes in terminal input */
#define	NAME_MAX		255	/* max bytes in a file name */
#define	NGROUPS_MAX		16	/* max supplemental group id's */
#define	OPEN_MAX		64	/* max open files per process */
#define	PATH_MAX		1024	/* max bytes in pathname */
#define	PIPE_BUF		512	/* max bytes for atomic pipe writes */
#define	IOV_MAX			1024	/* max elements in i/o vector */

#define	BC_BASE_MAX		99	/* max ibase/obase values in bc(1) */
#define	BC_DIM_MAX		2048	/* max array elements in bc(1) */
#define	BC_SCALE_MAX		99	/* max scale value in bc(1) */
#define	BC_STRING_MAX		1000	/* max const string length in bc(1) */
#define	COLL_WEIGHTS_MAX	0	/* max weights for order keyword */
#define	EXPR_NEST_MAX		32	/* max expressions nested in expr(1) */
#define	LINE_MAX		2048	/* max bytes in an input line */
#define	RE_DUP_MAX		255	/* max RE's in interval notation */
#endif	/* _ANSI_SOURCE */

/* POSIX.1 */
#define	_POSIX_ARG_MAX		4096
#define	_POSIX_CHILD_MAX	6
#define	_POSIX_LINK_MAX		8
#define	_POSIX_MAX_CANON	255
#define	_POSIX_MAX_INPUT	255
#define	_POSIX_NAME_MAX		14
#define	_POSIX_NGROUPS_MAX	0
#define	_POSIX_OPEN_MAX		16
#define	_POSIX_PATH_MAX		255
#define	_POSIX_PIPE_BUF		512
#define	_POSIX_SSIZE_MAX	32767
#define	_POSIX_STREAM_MAX	8
#define	_POSIX_TZNAME_MAX	3

/* POSIX.1b */
#define _POSIX_AIO_LISTIO_MAX	16
#define _POSIX_AIO_MAX		1
#define _POSIX_DELAYTIMER_MAX	32
#define _POSIX_MQ_OPEN_MAX	8
#define _POSIX_MQ_PRIO_MAX	32
#define _POSIX_RTSIG_MAX	0
#define _POSIX_SEM_NSEMS_MAX	256
#define _POSIX_SEM_VALUE_MAX	32767
#define _POSIX_SIGQUEUE_MAX	32
#define _POSIX_TIMER_MAX	32

/* POSIX.2 */
#define	_POSIX2_BC_BASE_MAX	99
#define	_POSIX2_BC_DIM_MAX	2048
#define	_POSIX2_BC_SCALE_MAX	99
#define	_POSIX2_BC_STRING_MAX	1000
#define	_POSIX2_EQUIV_CLASS_MAX	2
#define	_POSIX2_EXPR_NEST_MAX	32
#define	_POSIX2_LINE_MAX	2048
#define	_POSIX2_RE_DUP_MAX	255

/* X/Open */
#define	_XOPEN_IOV_MAX		16

#endif	/* _LIMITS_H_ */
