#ifndef _2114N_TYPES_H_
#define _2114N_TYPES_H_
struct bus_mode_s{
	volatile uint32_t padding0 : 11;
	volatile uint32_t dbo : 1;
	volatile uint32_t tap : 3;
	volatile uint32_t das : 1;
	volatile uint32_t cal : 2;
	volatile uint32_t pbl : 6;
	volatile uint32_t ble : 1;
	volatile uint32_t dsl : 5;
	volatile uint32_t bar : 1;
	volatile uint32_t swr : 1;
};

union bus_mode{
	struct bus_mode_s r;
	uint32_t data;
};

struct send_poll_s{
};

union send_poll{
	struct send_poll_s r;
	uint32_t data;
};

struct rcv_poll_s{
};

union rcv_poll{
	struct rcv_poll_s r;
	uint32_t data;
};

struct rcv_ring_s{
};

union rcv_ring{
	struct rcv_ring_s r;
	uint32_t data;
};

struct send_ring_s{
};

union send_ring{
	struct send_ring_s r;
	uint32_t data;
};

struct status_s{
	volatile uint32_t padding0 : 6;
	volatile uint32_t eb : 3;
	volatile uint32_t ts : 3;
	volatile uint32_t rs : 3;
	volatile uint32_t nis : 1;
	volatile uint32_t ais : 1;
	volatile uint32_t eri : 1;
	volatile uint32_t fbe : 1;
	volatile uint32_t lnf : 1;
	volatile uint32_t gte : 1;
	volatile uint32_t padding1 : 1;
	volatile uint32_t rwt : 1;
	volatile uint32_t rps : 1;
	volatile uint32_t ru : 1;
	volatile uint32_t ri : 1;
	volatile uint32_t unf : 1;
	volatile uint32_t lnp_anc : 1;
	volatile uint32_t tjt : 1;
	volatile uint32_t tu : 1;
	volatile uint32_t tps : 1;
	volatile uint32_t ti : 1;
};

union status{
	struct status_s r;
	uint32_t data;
};

struct op_mode_s{
	volatile uint32_t padding0 : 16;
	volatile uint32_t threshold_ctrl : 2;
	volatile uint32_t start_send : 1;
	volatile uint32_t padding1 : 1;
	volatile uint32_t operating_mode : 2;
	volatile uint32_t full_duplex : 1;
	volatile uint32_t padding2 : 1;
	volatile uint32_t pass_multi : 1;
	volatile uint32_t promisc : 1;
	volatile uint32_t padding3 : 1;
	volatile uint32_t inverse_filter : 1;
	volatile uint32_t pass_bad_frames : 1;
	volatile uint32_t hash_only : 1;
	volatile uint32_t start_rcv : 1;
	volatile uint32_t hash_perfect : 1;
};

union op_mode{
	struct op_mode_s r;
	uint32_t data;
};

struct irq_mask_s{
	volatile uint32_t padding0 : 15;
	volatile uint32_t nim : 1;
	volatile uint32_t aim : 1;
	volatile uint32_t erm : 1;
	volatile uint32_t sem : 1;
	volatile uint32_t lfm : 1;
	volatile uint32_t tmm : 1;
	volatile uint32_t padding1 : 1;
	volatile uint32_t rwm : 1;
	volatile uint32_t rsm : 1;
	volatile uint32_t rum : 1;
	volatile uint32_t rim : 1;
	volatile uint32_t unm : 1;
	volatile uint32_t lpm : 1;
	volatile uint32_t tjm : 1;
	volatile uint32_t tum : 1;
	volatile uint32_t tsm : 1;
	volatile uint32_t tim : 1;
};

union irq_mask{
	struct irq_mask_s r;
	uint32_t data;
};

struct srom_mii_s{
	volatile uint32_t padding0 : 17;
	volatile uint32_t rd : 1;
	volatile uint32_t wr : 1;
	volatile uint32_t br : 1;
	volatile uint32_t sr : 1;
	volatile uint32_t reg : 1;
	volatile uint32_t padding1 : 6;
	volatile uint32_t din : 1;
	volatile uint32_t dout : 1;
	volatile uint32_t clk : 1;
	volatile uint32_t cs : 1;
};

union srom_mii{
	struct srom_mii_s r;
	uint32_t data;
};

struct sia_conn_s{
	volatile uint32_t padding0 : 16;
	volatile uint32_t sdm : 12;
	volatile uint32_t aui : 1;
	volatile uint32_t cac : 1;
	volatile uint32_t padding1 : 1;
	volatile uint32_t srl : 1;
};

union sia_conn{
	struct sia_conn_s r;
	uint32_t data;
};

struct sia_txrx_s{
	volatile uint32_t padding0 : 16;
	volatile uint32_t tas : 1;
	volatile uint32_t spp : 1;
	volatile uint32_t ape : 1;
	volatile uint32_t lte : 1;
	volatile uint32_t sqe : 1;
	volatile uint32_t cld : 1;
	volatile uint32_t csq : 1;
	volatile uint32_t rsq : 1;
	volatile uint32_t ane : 1;
	volatile uint32_t mbo : 1;
	volatile uint32_t cpen : 2;
	volatile uint32_t lse : 1;
	volatile uint32_t dren : 1;
	volatile uint32_t lbk : 1;
	volatile uint32_t ecen : 1;
};

union sia_txrx{
	struct sia_txrx_s r;
	uint32_t data;
};

struct sia_general_s{
	volatile uint32_t padding0 : 16;
	volatile uint32_t lv2 : 1;
	volatile uint32_t le2 : 1;
	volatile uint32_t frl : 1;
	volatile uint32_t dpst : 1;
	volatile uint32_t lsd : 1;
	volatile uint32_t flf : 1;
	volatile uint32_t fusq : 1;
	volatile uint32_t tsck : 1;
	volatile uint32_t lv1 : 1;
	volatile uint32_t le1 : 1;
	volatile uint32_t rwr : 1;
	volatile uint32_t rwd : 1;
	volatile uint32_t abm : 1;
	volatile uint32_t jck : 1;
	volatile uint32_t huj : 1;
	volatile uint32_t jbd : 1;
};

union sia_general{
	struct sia_general_s r;
	uint32_t data;
};

#endif /* _2114N_TYPES_H_ */
