/****************************************************************************
 *
 *      $Id: pager.c,v 1.4 2003/08/06 22:52:04 benjl Exp $
 *
 *      Description: Example pager for the SOS project.
 *
 *      Author:      Ben Leslie
 *
 ****************************************************************************/

#include <types.h>
#include <l4.h>
#include <l4e.h>

#include "pager.h"

/*
  Pager is called from the syscall loop whenever a page fault 
  occurs. The current implementation simply maps whichever pages
  are asked for.
*/
int
pager(L4_ThreadId_t tid, L4_MsgTag_t tag, L4_Msg_t *msg)
{
	L4_Word_t addr;
	L4_MapItem_t map;
	int r;

	/* Get the faulting address */
	addr = L4_MsgWord (msg, 0);

	/* Request the page from sigma0 */
	r = l4e_request_page((void*)addr, 1);

	if (r != 0) {
		/* Failed! */
		return 1;
	}

	/* Construct fpage IPC message */
	map = L4_MapItem ( (L4_Fpage_t) 
			   (L4_FpageLog2 (addr, PAGEBITS).raw + 
			    L4_FullyAccessible),
			   addr);
	L4_MsgPut (msg, 0, 0, (L4_Word_t *) 0, 2, &map);
	L4_MsgLoad (msg);

	return 0;
}
